## astc-encoder 2.1+ds

=== Source/Makefile ===
# SPDX-License-Identifier: Apache-2.0
# -----------------------------------------------------------------------------
# Copyright 2019-2020 Arm Limited
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy
# of the License at:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations
# under the License.
# -----------------------------------------------------------------------------

# Configure the application to build
#
#   * astcenc - a full compressor/decompressor
#   * astcdec - a decompressor without compression support
#
# Note that "astcdec" is not a fully customized command line application. It
# will look like a normal astcenc build except for the binary name, and all
# operations requring a compression will fail. It is only intended for use as
# test vehicle for the decompress-only library testing.
APP ?= astcenc

# Configure the SIMD ISA and intrinsics support; valid values are:
#
#   * neon   - compile for Arm aarch64 + NEON
#   * sse2   - allow use of x86-64 + sse2
#   * sse4.2 - allow use of x86-64 + sse4.2 and popcnt
#   * avx2   - allow use of x86-64 + avx2, sse4.2, and popcnt
VEC ?= avx2

# Configure the build type; valid values are:
#
#   * release - build a fully optimized build without symbols
#   * profile - build a moderately optimized build, with symbols
#   * debug   - build an unoptimized build with symbols
BUILD ?= release

# Configure the build for ISA invariant output; valid values are:
#
#   * 0 - ISA invariance is off (default)
#   * 1 - ISA invariance is on
#
# Enabling ISA invariant output will give bit-exact compression across SSE2,
# SSE4.2, and AVX2. Thi will disable some optimizations for newer ISAs which
# cannot be reasonably implemented by the older ones, and will therefore reduce
# performance.
ISA_INV ?= 0

# ==================================================
# File listings

SOURCES = \
    astcenc_averages_and_directions.cpp \
    astcenc_block_sizes2.cpp \
    astcenc_color_quantize.cpp \
    astcenc_color_unquantize.cpp \
    astcenc_compress_symbolic.cpp \
    astcenc_compute_variance.cpp \
    astcenc_decompress_symbolic.cpp \
    astcenc_encoding_choice_error.cpp \
    astcenc_entry.cpp \
    astcenc_find_best_partitioning.cpp \
    astcenc_ideal_endpoints_and_weights.cpp \
    astcenc_image.cpp \
    astcenc_integer_sequence.cpp \
    astcenc_kmeans_partitioning.cpp \
    astcenc_mathlib.cpp \
    astcenc_mathlib_softfloat.cpp \
    astcenc_partition_tables.cpp \
    astcenc_percentile_tables.cpp \
    astcenc_pick_best_endpoint_format.cpp \
    astcenc_platform_isa_detection.cpp \
    astcenc_quantization.cpp \
    astcenc_symbolic_physical.cpp \
    astcenc_weight_align.cpp \
    astcenc_weight_quant_xfer_tables.cpp \
    astcenccli_error_metrics.cpp \
    astcenccli_image.cpp \
    astcenccli_image_load_store.cpp \
    astcenccli_platform_dependents.cpp \
    astcenccli_toplevel.cpp \
    astcenccli_toplevel_help.cpp

EXTERNAL_SOURCES = \
    stb_image.h \
    stb_image_write.h \
    tinyexr.h

HEADERS = \
    astcenc.h \
    astcenc_internal.h \
    astcenc_mathlib.h \
    astcenc_vecmathlib.h \
    astcenccli_internal.h \
    stb_image.h \
    stb_image_write.h \
    tinyexr.h

BINARY = $(APP)-$(VEC)

OBJECTS = $(SOURCES:.cpp=-$(BINARY).o)

EXTERNAL_OBJECTS = $(EXTERNAL_SOURCES:.h=-$(BINARY).o)

# ==================================================
# CXXFLAGS setup (and input validation). This appends on top of whatever
# CXXFLAGS are set on the command line, which is useful for integration
# with the oss-fuzz build infrastructure for fuzz testing

CXXFLAGS += -std=c++14 -fvisibility=hidden \
            -Wall -Wextra -Wpedantic -Werror -Werror=shadow -Wdouble-promotion

# Validate that the APP parameter is a supported value, and patch CXXFLAGS
ifeq ($(APP),astcenc)
# Nothing to set up
else
ifeq ($(APP),astcdec)
CXXFLAGS += -DASTCENC_DECOMPRESS_ONLY
else
$(error Unsupported app, use APP=astcenc/astcdec)
endif
endif

# Validate that the BUILD parameter is a supported value, and patch CXXFLAGS
ifeq ($(BUILD),release)
CXXFLAGS += -O3 -DNDEBUG -flto
else
ifeq ($(BUILD),profile)
CXXFLAGS += -O2 -g
else
ifeq ($(BUILD),debug)
CXXFLAGS += -O0 -g
else
$(error Unsupported build, use BUILD=release/profile/debug)
endif
endif
endif

# Validate that the VEC parameter is a supported value, and patch CXXFLAGS
ifeq ($(VEC),neon)
# NEON is on by default; no enabled needed
CXXFLAGS += -DASTCENC_SSE=0 -DASTCENC_AVX=0 -DASTCENC_POPCNT=0 -DASTCENC_VECALIGN=16
else
ifeq ($(VEC),sse2)
CXXFLAGS += -mfpmath=sse -msse2 -DASTCENC_SSE=20 -DASTCENC_AVX=0 -DASTCENC_POPCNT=0 -DASTCENC_VECALIGN=16
else
ifeq ($(VEC),sse4.2)
CXXFLAGS += -mfpmath=sse -msse4.2 -mpopcnt -DASTCENC_SSE=42 -DASTCENC_AVX=0 -DASTCENC_POPCNT=1 -DASTCENC_VECALIGN=16
else
ifeq ($(VEC),avx2)
CXXFLAGS += -mfpmath=sse -mavx2 -mpopcnt -DASTCENC_SSE=42 -DASTCENC_AVX=2 -DASTCENC_POPCNT=1 -DASTCENC_VECALIGN=32
else
$(error Unsupported VEC target, use VEC=neon/sse2/sse4.2/avx2)
endif
endif
endif
endif

# Validate that the ISA_ENV option is a valid option
ifeq ($(ISA_INV),0)
CXXFLAGS += -DASTCENC_ISA_INVARIANCE=0
else
ifeq ($(ISA_INV),1)
CXXFLAGS += -DASTCENC_ISA_INVARIANCE=1
else
$(error Unsupported ISA invariance, use ISA_INV=0/1)
endif
endif

# Disable necessary optimizations and warnings for third-party source files
CXXFLAGS_EXTERNAL = \
    $(CXXFLAGS) \
    -Wno-unused-parameter \
    -Wno-double-promotion \
    -fno-strict-aliasing

# ==================================================
# Exports for child make invocations

export CXX
export BUILD

# ==================================================
# Build rules for the command line wrapper

$(BINARY): $(EXTERNAL_OBJECTS) $(OBJECTS)
	@$(CXX) -o $@ $^ $(CXXFLAGS) -lpthread
	@echo "[Link] $@ (using $(VEC) $(BUILD))"

# Note: ensure NDEBUG is undefined; all three libraries are weak at runtime
# handling of corrupt files, relying on asserts to handle bad file input.
# Compiling with NDEBUG is a potential security risk.
stb_image-$(BINARY).o: stb_image.h
	@$(CXX) -c -x c++ -o $@ $< $(CXXFLAGS_EXTERNAL) -DSTB_IMAGE_IMPLEMENTATION \
		-DSTBI_NO_PSD -DSTBI_NO_GIF -DSTBI_NO_PIC -DSTBI_NO_PNM -UNDEBUG
	@echo "[C++] $<"

stb_image_write-$(BINARY).o: stb_image_write.h
	@$(CXX) -c -x c++ -o $@ $< $(CXXFLAGS_EXTERNAL) -DSTB_IMAGE_WRITE_IMPLEMENTATION \
		-UNDEBUG
	@echo "[C++] $<"

tinyexr-$(BINARY).o: tinyexr.h
	@$(CXX) -c -x c++ -o $@ $< $(CXXFLAGS) -DTINYEXR_IMPLEMENTATION -UNDEBUG
	@echo "[C++] $<"

$(OBJECTS): %-$(BINARY).o: %.cpp $(HEADERS)
	@$(CXX) -c -o $@ $(abspath $<) $(CXXFLAGS)
	@echo "[C++] $<"

# ==================================================
# Generic utility rules

clean:
	@rm -f *-$(BINARY).o
	@rm -f *-$(BINARY).obj
	@rm -f $(BINARY)
	@rm -f $(BINARY).exe
	@echo "[Clean] Removing $(VEC) build outputs"

batchbuild:
	# NEON is deliberately not here - needs a different CXX setting
	@+$(MAKE) -s VEC=sse2
	@+$(MAKE) -s VEC=sse4.2
	@+$(MAKE) -s VEC=avx2

batchclean:
	@+$(MAKE) -s clean VEC=neon
	@+$(MAKE) -s clean VEC=sse2
	@+$(MAKE) -s clean VEC=sse4.2
	@+$(MAKE) -s clean VEC=avx2

=== debian/changelog ===
astc-encoder (2.1+ds-3) unstable; urgency=medium

  * Fix keyword error in d/watch

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 07 Jan 2021 16:18:30 +0100

astc-encoder (2.1+ds-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 25 Dec 2020 16:54:45 +0100

astc-encoder (2.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #977127)

 -- Timo Röhling <timo@gaussglocke.de>  Sun, 13 Dec 2020 20:26:48 +0100

=== debian/control ===
Source: astc-encoder
Section: graphics
Priority: optional
Maintainer: Timo Röhling <timo@gaussglocke.de>
Build-Depends: debhelper-compat (= 13),
    cmake,
    libstb-dev,
    libtinyexr-dev
Homepage: https://github.com/ARM-software/astc-encoder
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder

Package: astcenc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ASTC image compression and decompression tool
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the command-line tool to compress and decompress
 images.

Package: libastcenc0d
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: ASTC image compression and decompression library
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the runtime library for ASTC support.

Package: libastcenc-dev
Section: libdevel
Architecture: any
Depends: libastcenc0d (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: ASTC image compression and decompression library headers
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the development headers to include ASTC support
 in other applications.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

%:
	dh $@ --buildsystem=cmake

execute_before_dh_auto_configure:
	cp debian/extra/CMakeLists.txt .

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DCMAKE_SKIP_RPATH=ON

## astc-encoder 3.3%2Bds

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0

SOVERSION := 1d
UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
		-DASTCENC_SOVERSION=$(SOVERSION) \
		-DCMAKE_CXX_VISIBILITY_PRESET=hidden \
		-DUNITTEST=$(UNITTEST)

## astc-encoder 3.3+ds

=== CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2021 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# CMake configuration
cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0069 NEW)  # LTO support
cmake_policy(SET CMP0091 NEW)  # MSVC runtime support

if(MSVC)
    add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
endif()

project(astcencoder VERSION 3.3.0)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(PACKAGE_ROOT astcenc)

include(CTest)

option(ISA_AVX2 "Enable builds for AVX2 SIMD")
option(ISA_SSE41 "Enable builds for SSE4.1 SIMD")
option(ISA_SSE2 "Enable builds for SSE2 SIMD")
option(ISA_NEON "Enable builds for NEON SIMD")
option(ISA_NONE "Enable builds for no SIMD")
option(ISA_NATIVE "Enable builds for native SIMD")
option(DECOMPRESSOR "Enable builds for decompression only")
option(DIAGNOSTICS "Enable builds for diagnostic trace")
option(UNITTEST "Enable builds for unit tests")
option(CLI "Enable build of CLI" ON)

set(UNIVERSAL_BUILD OFF)
set(MACOS_BUILD OFF)
set(MACOS_ARCH_LEN 0)

# Preflight for some macOS-specific build options
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    set(MACOS_BUILD ON)
    list(LENGTH CMAKE_OSX_ARCHITECTURES MACOS_ARCH_LEN)
endif()

# Count options which MUST be x64
set(X64_ISA_COUNT 0)
set(CONFIGS ${ISA_AVX2} ${ISA_SSE41} ${ISA_SSE2})
foreach(CONFIG ${CONFIGS})
    if(${CONFIG})
        math(EXPR X64_ISA_COUNT "${X64_ISA_COUNT} + 1")
    endif()
endforeach()

# Count options which MUST be arm64
set(ARM64_ISA_COUNT 0)
set(CONFIGS ${ISA_NEON})
foreach(CONFIG ${CONFIGS})
    if(${CONFIG})
        math(EXPR ARM64_ISA_COUNT "${ARM64_ISA_COUNT} + 1")
    endif()
endforeach()

# macOS builds
if("${MACOS_BUILD}")
    list(FIND CMAKE_OSX_ARCHITECTURES "x86_64" IS_X64)
    list(FIND CMAKE_OSX_ARCHITECTURES "arm64" IS_ARM64)
    list(FIND CMAKE_OSX_ARCHITECTURES "$(ARCHS_STANDARD)" IS_AUTO)

    # Turn list index into boolean
    if(${IS_X64} EQUAL -1)
        set(IS_X64 OFF)
    else()
        set(IS_X64 ON)
    endif()

    if(${IS_ARM64} EQUAL -1)
        set(IS_ARM64 OFF)
    else()
        set(IS_ARM64 ON)
    endif()

    if(${IS_AUTO} EQUAL -1)
        set(IS_AUTO OFF)
    else()
        set(IS_AUTO ON)
    endif()

    # Set up defaults if no more specific ISA set - use XCode's own defaults
    if((IS_ARM64 OR IS_AUTO) AND ("${ARM64_ISA_COUNT}" EQUAL 0) AND (NOT "${ISA_NONE}"))
        set(ARM64_ISA_COUNT 1)
        set(ISA_NEON ON)
    endif()

    if((IS_X64 OR IS_AUTO) AND ("${X64_ISA_COUNT}" EQUAL 0) AND (NOT "${ISA_NONE}"))
        set(X64_ISA_COUNT 1)
        set(ISA_SSE41 ON)
    endif()

    # User might be doing multi-architecture - XCode sets this at runtime
    if("${IS_AUTO}")
        if(("${ARM64_ISA_COUNT}" GREATER 1) OR ("${X64_ISA_COUNT}" GREATER 1))
            message(FATAL_ERROR "For macOS universal binaries only one backend per architecture is allowed.")
        endif()

        set(UNIVERSAL_BUILD ON)

    # User requested explicit multi-architecture universal build
    elseif("${MACOS_ARCH_LEN}" GREATER 2)
        message(FATAL_ERROR "For macOS universal binaries only x86_64 and arm64 builds are allowed.")

    elseif("${MACOS_ARCH_LEN}" EQUAL 2)
        if(NOT (${IS_X64} AND ${IS_ARM64}))
            message(FATAL_ERROR "For macOS universal binaries only x86_64 and arm64 builds are allowed.")
        endif()

        if(("${ARM64_ISA_COUNT}" GREATER 1) OR ("${X64_ISA_COUNT}" GREATER 1))
            message(FATAL_ERROR "For macOS universal binaries only one backend per architecture is allowed.")
        endif()

        set(UNIVERSAL_BUILD ON)

    # User requested explicit single architecture build
    elseif("${MACOS_ARCH_LEN}" EQUAL 1)
        if("${IS_X64}" AND "${ARM64_ISA_COUNT}")
            message(FATAL_ERROR "For macOS x86_64 builds an arm64 backend cannot be specified.")
        endif()

        if("${IS_ARM64}" AND "${X64_ISA_COUNT}")
            message(FATAL_ERROR "For macOS arm64 builds an x86_64 backend cannot be specified.")
        endif()

    # Else is this a implicit multi-architecture universal build?
    elseif(("${ARM64_ISA_COUNT}" EQUAL 1) AND ("${X64_ISA_COUNT}" GREATER 1))
        string(CONCAT MSG "For macOS setting multiple architecture backends builds a universal binary. "
                          "For universal binaries only one backend per architecture is allowed.")
        message(FATAL_ERROR "${MSG}")

    elseif(("${X64_ISA_COUNT}" EQUAL 1) AND ("${ARM64_ISA_COUNT}" GREATER 1))
        string(CONCAT MSG "For macOS setting multiple architecture backends builds a universal binary. "
                          "For universal binaries only one backend per architecture is allowed.")
        message(FATAL_ERROR "${MSG}")

    elseif(("${ARM64_ISA_COUNT}" EQUAL 1) AND ("${X64_ISA_COUNT}" EQUAL 1))
        set(UNIVERSAL_BUILD ON)
        set(CMAKE_OSX_ARCHITECTURES "arm64;x86_64")

    # Else is this an implicit single architecture build?
    elseif("${ARM64_ISA_COUNT}" EQUAL 1)
        set(CMAKE_OSX_ARCHITECTURES "arm64")

    elseif("${X64_ISA_COUNT}" EQUAL 1)
        set(CMAKE_OSX_ARCHITECTURES "x86_64")

    else()
        # Do nothing here - assume it defaults to host?

    endif()

# Non-macOS builds
else()
    if(("${ARM64_ISA_COUNT}" GREATER 0) AND ("${X64_ISA_COUNT}" GREATER 0))
        message(FATAL_ERROR "Builds can only support a single architecture per configure.")
    endif()
endif()

# If nothing more specific is set then fall back on the compiler's defaults
if(("${ARM64_ISA_COUNT}" EQUAL 0) AND ("${X64_ISA_COUNT}" EQUAL 0) AND (NOT "${ISA_NONE}"))
    set(ISA_NATIVE ON)
endif()

function(printopt optName optVal)
    if(${optVal})
        message(STATUS "  ${optName} -  ON")
    else()
        message(STATUS "  ${optName} - OFF")
    endif()
endfunction()

printopt("AVX2 backend   " ${ISA_AVX2})
printopt("SSE4.1 backend " ${ISA_SSE41})
printopt("SSE2 backend   " ${ISA_SSE2})
printopt("NEON backend   " ${ISA_NEON})
printopt("NONE backend   " ${ISA_NONE})
printopt("NATIVE backend " ${ISA_NATIVE})
if("${MACOS_BUILD}")
    printopt("Universal bin  " ${UNIVERSAL_BUILD})
endif()
printopt("Decompressor   " ${DECOMPRESSOR})
printopt("Diagnostics    " ${DIAGNOSTICS})
printopt("Unit tests     " ${UNITTEST})

# Subcomponents
add_subdirectory(Source)

# Configure package archive
if(PACKAGE)
    if("${MACOS_BUILD}")
        string(TOLOWER "macOS" PKG_OS)
    else()
        string(TOLOWER ${CMAKE_SYSTEM_NAME} PKG_OS)
    endif()

    set(PKG_VER ${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR})

    set(CPACK_PACKAGE_FILE_NAME "astcenc-${PKG_VER}-${PKG_OS}-${PACKAGE}")
    set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
    set(CPACK_PACKAGE_CHECKSUM SHA256)
    set(CPACK_GENERATOR ZIP)

    include(CPack) # Must be included after CPack configuration.
endif()

=== Source/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2021 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# Overwrite the LTO flags to force fat LTO; worth 3-4% performance
# See https://gitlab.kitware.com/cmake/cmake/-/issues/16808
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang" AND ${CLI})
    set(CMAKE_CXX_COMPILE_OPTIONS_IPO "-flto")
endif()

if(${DECOMPRESSOR})
    set(CODEC dec)
else()
    set(CODEC enc)
endif()

if(${UNIVERSAL_BUILD})
    if(${ISA_AVX2})
        set(ISA_SIMD "avx2")
    elseif(${ISA_SSE41})
        set(ISA_SIMD "sse4.1")
    elseif(${ISA_SSE2})
        set(ISA_SIMD "sse2")
    endif()
    include(cmake_core.cmake)
else()
    set(ARTEFACTS native none neon avx2 sse4.1 sse2)
    set(CONFIGS ${ISA_NATIVE} ${ISA_NONE} ${ISA_NEON} ${ISA_AVX2} ${ISA_SSE41} ${ISA_SSE2})
    list(LENGTH ARTEFACTS ARTEFACTS_LEN)
    math(EXPR ARTEFACTS_LEN "${ARTEFACTS_LEN} - 1")

    foreach(INDEX RANGE ${ARTEFACTS_LEN})
        list(GET ARTEFACTS ${INDEX} ARTEFACT)
        list(GET CONFIGS ${INDEX} CONFIG)
        if(${CONFIG})
            set(ISA_SIMD ${ARTEFACT})
            include(cmake_core.cmake)
        endif()
    endforeach()
endif()

# - - - - - - - - - - - - - - - - - -
# Unit testing
if(${UNITTEST})
    set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)
    add_subdirectory(GoogleTest)
    enable_testing()
    add_subdirectory(UnitTest)
endif()

=== Test/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = DocSource
BUILDDIR      = DocOut

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== Source/UnitTest/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2021 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

if(${UNIVERSAL_BUILD})
    if(${ISA_AVX2})
        set(ISA_SIMD "avx2")
    elseif(${ISA_SSE41})
        set(ISA_SIMD "sse4.1")
    elseif(${ISA_SSE2})
        set(ISA_SIMD "sse2")
    endif()
    include(cmake_core.cmake)
else()
    set(ARTEFACTS native none neon avx2 sse4.1 sse2)
    set(CONFIGS ${ISA_NATIVE} ${ISA_NONE} ${ISA_NEON} ${ISA_AVX2} ${ISA_SSE41} ${ISA_SSE2})
    list(LENGTH ARTEFACTS ARTEFACTS_LEN)
    math(EXPR ARTEFACTS_LEN "${ARTEFACTS_LEN} - 1")

    foreach(INDEX RANGE ${ARTEFACTS_LEN})
        list(GET ARTEFACTS ${INDEX} ARTEFACT)
        list(GET CONFIGS ${INDEX} CONFIG)
        if(${CONFIG})
            set(ISA_SIMD ${ARTEFACT})
            include(cmake_core.cmake)
        endif()
    endforeach()
endif()

=== Utils/Example/CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2021 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# CMake configuration
cmake_minimum_required(VERSION 3.15)
include(ExternalProject)

project(astcencoder_example VERSION 1.0.0)

# Add the external project and pull out the project directories we need

# The default build is a native build which supports the highest level of SIMD
# exposed by the compiler when using default compiler flags. Add a single
# SIMD enable to the CMAKE_CACHE_ARGS option to force something specific, but
# remember to change the link library in target_link_libraries() to match.
#
#  *  Add "-DISA_SSE2:String=ON" and link against "astcenc-sse2-static"
#  *  Add "-DISA_SSE41:String=ON" and link against "astcenc-sse4.1-static"
#  *  Add "-DISA_AVX2:String=ON" and link against "astcenc-avx2-static"
#  *  Add "-DISA_NEON:String=ON" and link against "astcenc-neon-static"
ExternalProject_Add(astcencoder
    GIT_REPOSITORY https://github.com/ARM-software/astc-encoder
    GIT_TAG main
    CMAKE_CACHE_ARGS -DCLI:String=OFF
    INSTALL_COMMAND "")

ExternalProject_Get_property(astcencoder
    SOURCE_DIR)

ExternalProject_Get_property(astcencoder
    BINARY_DIR)

# Build the command line
add_executable(astcenc_example astc_api_example.cpp)

# ... with astcencoder as a dependency
add_dependencies(astcenc_example astcencoder)

# ... with astcencoder Source dir on the include path
target_include_directories(astcenc_example
    PRIVATE
        ${SOURCE_DIR}/Source)

# ... with astcencoder Binary dir on the library path and as a library dep
target_link_directories(astcenc_example
    PRIVATE
        ${BINARY_DIR}/Source)

target_link_libraries(astcenc_example
    PRIVATE
        astcenc-native-static)

=== debian/changelog ===
astc-encoder (3.3+ds-1) unstable; urgency=medium

  * New upstream version 3.3+ds
  * Refresh d/patches
  * Add Build-Depends-Package to .symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 10 Nov 2021 10:13:07 +0100

astc-encoder (3.2+ds-2) unstable; urgency=medium

  * Fix version number in library file name

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Aug 2021 23:07:38 +0200

astc-encoder (3.2+ds-1) unstable; urgency=medium

  * New upstream version 3.2+ds
  * Refresh d/patches
  * Add .symbols; ABI remained stable
  * Bump Standards-Version to 4.6.0

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Aug 2021 15:56:55 +0200

astc-encoder (3.1+ds-3) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Aug 2021 21:04:25 +0200

astc-encoder (3.1+ds-2) experimental; urgency=medium

  * Always disable Neon instruction set
  * Hide private symbols

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Aug 2021 20:04:41 +0200

astc-encoder (3.1+ds-1) experimental; urgency=medium

  * New upstream version 3.1+ds
  * Refresh d/patches
  * Bump version

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Aug 2021 16:08:40 +0200

astc-encoder (3.0+ds-2) experimental; urgency=medium

  * Link against pthread

 -- Timo Röhling <roehling@debian.org>  Sun, 13 Jun 2021 23:38:21 +0200

astc-encoder (3.0+ds-1) experimental; urgency=medium

  * New upstream version 3.0+ds
    - Fixes FTBFS with -march=x86-64-v2 (Closes: #983929)

 -- Timo Röhling <roehling@debian.org>  Fri, 04 Jun 2021 17:31:32 +0200

astc-encoder (2.5+ds-1) experimental; urgency=medium

  * New upstream version 2.5+ds
  * Bump to SOVERSION 1d
  * Update maintainer info
  * Switch to upstream CMake build system
  * Add autopkgtest

 -- Timo Röhling <roehling@debian.org>  Wed, 02 Jun 2021 22:57:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: astc-encoder
 Section: graphics
 Priority: optional
-Maintainer: Timo Röhling <timo@gaussglocke.de>
+Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13),
     cmake,
     libstb-dev,
-    libtinyexr-dev
+    libtinyexr-dev,
+    libz-dev,
+    pkg-config <!nocheck>, libgtest-dev <!nocheck>
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
@@ -28,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc0d
+Package: libastcenc1d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -48,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc0d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc1d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by

=== debian/tests/control ===
Tests: build-and-run
Depends: libastcenc-dev, cmake, g++ | c++-compiler
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1.tar.gz/,\
     dversionmangle=s/\+ds\d*$//,oversionmangle=s/$/+ds/,\
     repack \
https://github.com/ARM-software/astc-encoder/releases/latest .*/v?(\d\S+)\.tar\.gz

## astc-encoder 4.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2021 Arm Limited
+#  Copyright 2020-2022 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -24,13 +24,12 @@
     add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
 endif()
 
-project(astcencoder VERSION 3.3.0)
+project(astcencoder VERSION 4.1.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
-set(PACKAGE_ROOT astcenc)
 
 include(CTest)
 
@@ -42,7 +41,9 @@
 option(ISA_NATIVE "Enable builds for native SIMD")
 option(DECOMPRESSOR "Enable builds for decompression only")
 option(DIAGNOSTICS "Enable builds for diagnostic trace")
+option(ASAN "Enable builds width address sanitizer")
 option(UNITTEST "Enable builds for unit tests")
+option(NO_INVARIANCE "Enable builds without invariance")
 option(CLI "Enable build of CLI" ON)
 
 set(UNIVERSAL_BUILD OFF)
@@ -183,12 +184,15 @@
 
 function(printopt optName optVal)
     if(${optVal})
-        message(STATUS "  ${optName} -  ON")
-    else()
-        message(STATUS "  ${optName} - OFF")
+        message(STATUS "  ${optName}  - ON")
+    else()
+        message(STATUS "  ${optName}  - OFF")
     endif()
 endfunction()
 
+if("${BLOCK_MAX_TEXELS}")
+     message(STATUS "  Max block texels - ${BLOCK_MAX_TEXELS}")
+endif()
 printopt("AVX2 backend   " ${ISA_AVX2})
 printopt("SSE4.1 backend " ${ISA_SSE41})
 printopt("SSE2 backend   " ${ISA_SSE2})
@@ -199,7 +203,9 @@
     printopt("Universal bin  " ${UNIVERSAL_BUILD})
 endif()
 printopt("Decompressor   " ${DECOMPRESSOR})
+printopt("No invariance  " ${NO_INVARIANCE})
 printopt("Diagnostics    " ${DIAGNOSTICS})
+printopt("ASAN           " ${ASAN})
 printopt("Unit tests     " ${UNITTEST})
 
 # Subcomponents
@@ -213,9 +219,7 @@
         string(TOLOWER ${CMAKE_SYSTEM_NAME} PKG_OS)
     endif()
 
-    set(PKG_VER ${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR})
-
-    set(CPACK_PACKAGE_FILE_NAME "astcenc-${PKG_VER}-${PKG_OS}-${PACKAGE}")
+    set(CPACK_PACKAGE_FILE_NAME "astcenc-${CMAKE_PROJECT_VERSION}-${PKG_OS}-${PACKAGE}")
     set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
     set(CPACK_PACKAGE_CHECKSUM SHA256)
     set(CPACK_GENERATOR ZIP)

=== debian/changelog ===
astc-encoder (4.1.0+ds-1) unstable; urgency=medium

  * New upstream version 4.1.0+ds

 -- Timo Röhling <roehling@debian.org>  Sun, 21 Aug 2022 19:00:52 +0200

astc-encoder (4.0.0+ds-2) unstable; urgency=medium

  * Fix big endian unit test failure

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Jul 2022 21:47:41 +0200

astc-encoder (4.0.0+ds-1) unstable; urgency=medium

  * New upstream version 4.0.0+ds
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Jul 2022 00:57:02 +0200

astc-encoder (3.7+ds-1) unstable; urgency=medium

  * New upstream version 3.7+ds

 -- Timo Röhling <roehling@debian.org>  Fri, 29 Apr 2022 13:04:49 +0200

astc-encoder (3.6+ds-1) unstable; urgency=medium

  * New upstream version 3.6+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 11 Apr 2022 09:30:18 +0200

astc-encoder (3.5+ds-1) unstable; urgency=medium

  * New upstream version 3.5+ds

 -- Timo Röhling <roehling@debian.org>  Tue, 22 Mar 2022 09:38:32 +0100

astc-encoder (3.4+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 06 Mar 2022 10:54:36 +0100

astc-encoder (3.4+ds-1) experimental; urgency=medium

  * New upstream version 3.4+ds
  * Bump SONAME
    - libastcenc.so.1d -> libastcenc.so.2d

 -- Timo Röhling <roehling@debian.org>  Wed, 02 Mar 2022 12:03:01 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
     libz-dev,
     pkg-config <!nocheck>, libgtest-dev <!nocheck>
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
@@ -30,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc1d
+Package: libastcenc2d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -50,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc1d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc2d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
 export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0
 
-SOVERSION := 1d
+SOVERSION := 2d
 UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:

## astc-encoder 4.2.0%2Bds

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2021 Arm Limited
+#  Copyright 2020-2022 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -37,16 +37,16 @@
     endif()
     include(cmake_core.cmake)
 else()
-    set(ARTEFACTS native none neon avx2 sse4.1 sse2)
+    set(ARTIFACTS native none neon avx2 sse4.1 sse2)
     set(CONFIGS ${ISA_NATIVE} ${ISA_NONE} ${ISA_NEON} ${ISA_AVX2} ${ISA_SSE41} ${ISA_SSE2})
-    list(LENGTH ARTEFACTS ARTEFACTS_LEN)
-    math(EXPR ARTEFACTS_LEN "${ARTEFACTS_LEN} - 1")
+    list(LENGTH ARTIFACTS ARTIFACTS_LEN)
+    math(EXPR ARTIFACTS_LEN "${ARTIFACTS_LEN} - 1")
 
-    foreach(INDEX RANGE ${ARTEFACTS_LEN})
-        list(GET ARTEFACTS ${INDEX} ARTEFACT)
+    foreach(INDEX RANGE ${ARTIFACTS_LEN})
+        list(GET ARTIFACTS ${INDEX} ARTIFACT)
         list(GET CONFIGS ${INDEX} CONFIG)
         if(${CONFIG})
-            set(ISA_SIMD ${ARTEFACT})
+            set(ISA_SIMD ${ARTIFACT})
             include(cmake_core.cmake)
         endif()
     endforeach()

=== debian/changelog ===
astc-encoder (4.2.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 13 Nov 2022 09:06:41 +0100

astc-encoder (4.2.0+ds-1) experimental; urgency=medium

  * New upstream version 4.2.0+ds
  * Bump SONAME to 3d

 -- Timo Röhling <roehling@debian.org>  Fri, 11 Nov 2022 22:40:19 +0100

astc-encoder (4.1.0+ds-2) unstable; urgency=medium

  * Update d/watch
  * Do not embed libstb and tinyexr

 -- Timo Röhling <roehling@debian.org>  Sun, 02 Oct 2022 19:49:48 +0200

## astc-encoder 4.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
     add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
 endif()
 
-project(astcencoder VERSION 4.1.0)
+project(astcencoder VERSION 4.2.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== Source/UnitTest/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2021 Arm Limited
+#  Copyright 2020-2022 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -25,16 +25,16 @@
     endif()
     include(cmake_core.cmake)
 else()
-    set(ARTEFACTS native none neon avx2 sse4.1 sse2)
+    set(ARTIFACTS native none neon avx2 sse4.1 sse2)
     set(CONFIGS ${ISA_NATIVE} ${ISA_NONE} ${ISA_NEON} ${ISA_AVX2} ${ISA_SSE41} ${ISA_SSE2})
-    list(LENGTH ARTEFACTS ARTEFACTS_LEN)
-    math(EXPR ARTEFACTS_LEN "${ARTEFACTS_LEN} - 1")
+    list(LENGTH ARTIFACTS ARTIFACTS_LEN)
+    math(EXPR ARTIFACTS_LEN "${ARTIFACTS_LEN} - 1")
 
-    foreach(INDEX RANGE ${ARTEFACTS_LEN})
-        list(GET ARTEFACTS ${INDEX} ARTEFACT)
+    foreach(INDEX RANGE ${ARTIFACTS_LEN})
+        list(GET ARTIFACTS ${INDEX} ARTIFACT)
         list(GET CONFIGS ${INDEX} CONFIG)
         if(${CONFIG})
-            set(ISA_SIMD ${ARTEFACT})
+            set(ISA_SIMD ${ARTIFACT})
             include(cmake_core.cmake)
         endif()
     endforeach()

=== Utils/Example/CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ExternalProject_Add(astcencoder
     GIT_REPOSITORY https://github.com/ARM-software/astc-encoder
     GIT_TAG main
-    CMAKE_CACHE_ARGS -DCLI:String=OFF
+    CMAKE_CACHE_ARGS -DCLI:STRING=OFF -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
     INSTALL_COMMAND "")
 
 ExternalProject_Get_property(astcencoder

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc2d
+Package: libastcenc3d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -50,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc2d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc3d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
 export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0
 
-SOVERSION := 2d
+SOVERSION := 3d
 UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 dversionmangle=auto,oversionmangle=s/$/+ds/,repack \
 https://api.github.com/repos/ARM-software/astc-encoder/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@

## astc-encoder 4.5.0+ds

=== CMakeLists.txt ===
#  SPDX-License-Identifier: Apache-2.0
#  ----------------------------------------------------------------------------
#  Copyright 2020-2023 Arm Limited
#
#  Licensed under the Apache License, Version 2.0 (the "License"); you may not
#  use this file except in compliance with the License. You may obtain a copy
#  of the License at:
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#  License for the specific language governing permissions and limitations
#  under the License.
#  ----------------------------------------------------------------------------

# CMake configuration
cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0069 NEW)  # LTO support
cmake_policy(SET CMP0091 NEW)  # MSVC runtime support

if(MSVC)
    add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
endif()

project(astcencoder VERSION 4.5.0)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(CMAKE_XCODE_ATTRIBUTE_VALID_ARCHS "x86_64 x86_64h arm64")

include(CTest)

option(ASTCENC_ISA_AVX2 "Enable astcenc builds for AVX2 SIMD")
option(ASTCENC_ISA_SSE41 "Enable astcenc builds for SSE4.1 SIMD")
option(ASTCENC_ISA_SSE2 "Enable astcenc builds for SSE2 SIMD")
option(ASTCENC_ISA_NEON "Enable astcenc builds for NEON SIMD")
option(ASTCENC_ISA_NONE "Enable astcenc builds for no SIMD")
option(ASTCENC_ISA_NATIVE "Enable astcenc builds for native SIMD")
option(ASTCENC_DECOMPRESSOR "Enable astcenc builds for decompression only")
option(ASTCENC_SHAREDLIB "Enable astcenc builds with core library shared objects")
option(ASTCENC_DIAGNOSTICS "Enable astcenc builds with diagnostic trace")
option(ASTCENC_ASAN "Enable astcenc builds with address sanitizer")
option(ASTCENC_UNITTEST "Enable astcenc builds with unit tests")
option(ASTCENC_INVARIANCE "Enable astcenc floating point invariance" ON)
option(ASTCENC_CLI "Enable build of astcenc command line tools" ON)

# Preflight for some macOS-specific build options
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    option(ASTCENC_UNIVERSAL_BUILD "Enable universal multi-arch build" ON)

    if(${ASTCENC_UNIVERSAL_BUILD})
        set(ASTCENC_ISA_SSE41 ON)
        set(ASTCENC_ISA_AVX2 ON)
        set(ASTCENC_ISA_NEON ON)

        if(${ASTCENC_ISA_SSE2})
            message(FATAL_ERROR "ISA_SSE2 cannot be used in a universal build")
        endif()

        if(${ASTCENC_ISA_NONE})
            message(FATAL_ERROR "ISA_NONE cannot be used in a universal build")
        endif()

        if(${ASTCENC_ISA_NATIVE})
            message(FATAL_ERROR "ISA_NATIVE cannot be used in a universal build")
        endif()
    endif()
else()
    set(ASTCENC_UNIVERSAL_BUILD OFF)
endif()

# Count options which MUST be x64
set(ASTCENC_X64_ISA_COUNT 0)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_AVX2} ${ASTCENC_ISA_SSE41} ${ASTCENC_ISA_SSE2})
foreach(ASTCENC_CONFIG ${ASTCENC_CONFIGS})
    if(${ASTCENC_CONFIG})
        math(EXPR ASTCENC_X64_ISA_COUNT "${ASTCENC_X64_ISA_COUNT} + 1")
    endif()
endforeach()

# Count options which MUST be arm64
set(ASTCENC_ARM64_ISA_COUNT 0)
set(ASTCENC_CONFIGS ${ASTCENC_ISA_NEON})
foreach(ASTCENC_CONFIG ${ASTCENC_CONFIGS})
    if(${ASTCENC_CONFIG})
        math(EXPR ASTCENC_ARM64_ISA_COUNT "${ASTCENC_ARM64_ISA_COUNT} + 1")
    endif()
endforeach()

# Non-macOS builds
if(NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    if(("${ASTCENC_ARM64_ISA_COUNT}" GREATER 0) AND ("${ASTCENC_X64_ISA_COUNT}" GREATER 0))
        message(FATAL_ERROR "Builds can only support a single architecture per configure.")
    endif()
endif()

# If nothing more specific is set then fall back on the compiler's defaults
if(("${ASTCENC_ARM64_ISA_COUNT}" EQUAL 0) AND ("${ASTCENC_X64_ISA_COUNT}" EQUAL 0) AND (NOT "${ASTCENC_ISA_NONE}"))
    set(ASTCENC_ISA_NATIVE ON)
endif()

function(printopt optName optVal)
    if(${optVal})
        message(STATUS "  ${optName}  - ON")
    else()
        message(STATUS "  ${optName}  - OFF")
    endif()
endfunction()

if("${ASTCENC_BLOCK_MAX_TEXELS}")
     message(STATUS "  Max block texels - ${ASTCENC_BLOCK_MAX_TEXELS}")
endif()

printopt("AVX2 backend   " ${ASTCENC_ISA_AVX2})
printopt("SSE4.1 backend " ${ASTCENC_ISA_SSE41})
printopt("SSE2 backend   " ${ASTCENC_ISA_SSE2})
printopt("NEON backend   " ${ASTCENC_ISA_NEON})
printopt("NONE backend   " ${ASTCENC_ISA_NONE})
printopt("NATIVE backend " ${ASTCENC_ISA_NATIVE})
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
    printopt("Universal bin  " ${ASTCENC_UNIVERSAL_BUILD})
endif()
printopt("Invariance     " ${ASTCENC_INVARIANCE})
printopt("Shared libs    " ${ASTCENC_SHAREDLIB})
printopt("Decompressor   " ${ASTCENC_DECOMPRESSOR})
printopt("Diagnostics    " ${ASTCENC_DIAGNOSTICS})
printopt("ASAN           " ${ASTCENC_ASAN})
printopt("Unit tests     " ${ASTCENC_UNITTEST})

# Subcomponents
add_subdirectory(Source)

# Configure package archive
if(ASTCENC_PACKAGE)
    if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
        string(TOLOWER "macOS" ASTCENC_PKG_OS)
    else()
        string(TOLOWER ${CMAKE_SYSTEM_NAME} ASTCENC_PKG_OS)
    endif()

    set(CPACK_PACKAGE_FILE_NAME "astcenc-${CMAKE_PROJECT_VERSION}-${ASTCENC_PKG_OS}-${ASTCENC_PACKAGE}")
    set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
    set(CPACK_PACKAGE_CHECKSUM SHA256)
    set(CPACK_GENERATOR ZIP)

    include(CPack) # Must be included after CPack configuration.
endif()

=== debian/changelog ===
astc-encoder (4.5.0+ds-2) unstable; urgency=medium

  * Fix linkage for astcenc CLI (Closes: #1039485)

 -- Timo Röhling <roehling@debian.org>  Mon, 26 Jun 2023 15:58:08 +0200

astc-encoder (4.5.0+ds-1) unstable; urgency=medium

  * New upstream version 4.5.0+ds
  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Thu, 22 Jun 2023 09:46:15 +0200

astc-encoder (4.4.0+ds-1) experimental; urgency=medium

  * New upstream version 4.4.0+ds
  * Bump Standards-Version to 4.6.2
  * Bump SONAME to 4d
  * Build and install static library as well

 -- Timo Röhling <roehling@debian.org>  Sat, 17 Jun 2023 21:44:35 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
     libz-dev,
     pkg-config <!nocheck>, libgtest-dev <!nocheck>
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
@@ -30,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc3d
+Package: libastcenc4d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -50,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc3d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc4d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
 export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0
 
-SOVERSION := 3d
+SOVERSION := 4d
 UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:
@@ -17,5 +17,5 @@
 		-DCMAKE_SKIP_RPATH=ON \
 		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
 		-DASTCENC_SOVERSION=$(SOVERSION) \
-		-DCMAKE_CXX_VISIBILITY_PRESET=hidden \
-		-DUNITTEST=$(UNITTEST)
+		-DASTCENC_UNITTEST=$(UNITTEST) \
+		-DASTCENC_SHAREDLIB=ON
